Extensions to OSPF for Advertising Prefix Administrative Tags
Acee Lindem, Ed.
LabN Consulting, L.L.C.
301 Midenhall Way
Cary
NC
USA
27513
acee.ietf@gmail.com
Peter Psenak
Cisco Systems
Apollo Business Center
Mlynske nivy 43
Bratislava 821 09
Slovakia
ppsenak@cisco.com
Yingzhen Qu
Futurewei Technologies
2330 Central Expressway
Santa Clara
CA
95050
USA
yingzhen.ietf@gmail.com
It is useful for routers in OSPFv2 and OSPFv3 routing domains to be able to associate tags with prefixes. Previously, OSPFv2 and OSPFv3 were relegated to a single tag and only for AS External and Not-So-Stubby-Area (NSSA) prefixes. With the flexible encodings provided by OSPFv2 Prefix/Link Attribute Advertisement and OSPFv3 Extended LSAs, multiple administrative tags may be advertised for all types of prefixes. These administrative tags can be used for many applications including route redistribution policy, selective prefix prioritization, selective IP Fast-ReRoute (IPFRR) prefix protection, and many others.

Introduction
It is useful for routers in OSPFv2 [RFC2328] and OSPFv3 [RFC5340] routing domains to be able to associate tags with prefixes. Previously, OSPFv2 and OSPFv3 were relegated to a single tag and only for AS External and Not-So-Stubby-Area (NSSA) prefixes. With the flexible encodings provided by OSPFv2 Prefix/Link Attribute Advertisement ([RFC7684]) and OSPFv3 Extended LSA ([RFC8362]), multiple administrative tags may be advertised for all types of prefixes. These administrative tags can be used in many applications including (but not limited to):
1. Controlling which routes are redistributed into other protocols for re-advertisement.
2. Prioritizing selected prefixes for faster convergence and installation in the forwarding plane.
3. Identifying selected prefixes for Loop-Free Alternative (LFA) protection.
Throughout this document, OSPF is used when the text applies to both OSPFv2 and OSPFv3. OSPFv2 or OSPFv3 is used when the text is specific to one version of the OSPF protocol.
The definition of the 64-bit tag was considered but discard given that there is no strong requirement or use case.
The IS-IS protocol supports a similar mechanism that is described in RFC 5130 [RFC5130].

Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.

Administrative Tag Sub-TLV
This document creates a new Administrative Tag Sub-TLV for OSPFv2 and OSPFv3. This Sub-TLV specifies one or more 32-bit unsigned integers that may be associated with an OSPF advertised prefix. The precise usage of these tags is beyond the scope of this document.
The format of the Administrative Tag TLV is as follows:

Administrative Tag Sub-TLV

    0                   1                   2                   3
    0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |              Type             |             Length            |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |             First Administrative Tag                          |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |                             o                                 |
                                 o
   |                             o                                 |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |             Last Administrative Tag                           |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

   Type     A 16-bit field set to TBD.

   Length   A 16-bit field that indicates the length of the value
            portion in octets and MUST be a multiple of 4 octets
            dependent on the number of administrative tags
            advertised. At least one administrative tag MUST be
            advertised.

   Value    A variable length list of one or more administrative
            tags.

This sub-TLV will carry one or more 32-bit unsigned integer values that will be used as administrative tags. If the length is 0 or not a multiple of 4 octets, the sub-TLV MUST be ignored and the reception SHOULD be logged for further analysis (subject to rate-limiting).

Administrative Tag Applicability
The administrative tag TLV specified herein will be valid as a sub-TLV of the following TLVs specified in [RFC7684]:
1. Extended Prefix TLV advertised in the OSPFv2 Extended Prefix LSA
The administrative tag TLV specified herein will be valid as a sub-TLV of the following TLVs specified in [RFC8362]:
1. Inter-Area-Prefix TLV advertised in the E-Inter-Area-Prefix-LSA
2. Intra-Area-Prefix TLV advertised in the E-Intra-Area-Prefix-LSA.
3. External-Prefix TLV advertised in the E-AS-External-LSA and the E-NSSA-LSA
The administrative tag TLV specified herein will be valid as a sub-TLV of the following TLVs specified in [RFC9513]:
1. SRv6 Locator TLV advertised in the SRv6 Locator LSA

Protocol Operation
An OSPF router supporting this specification MUST be able to advertise and interpret at least one tag for all type of prefixes. An OSPF router supporting this specification MAY be able to advertise and propagate multiple tags. The maximum tags that an implementation supports is a local matter depending upon supported applications using prefix tags. Depending on the application, the number of tags supported by the OSPF routers in the OSPF routing domain MAY limit deployment of that application.
When tags are advertised for AS External or NSSA LSA prefixes, the existing tag in the OSPFv2 and OSPFv3 AS-External-LSA and NSSA-LSA encodings MUST be utilized for the first tag. Additional tags MAY be advertised using the Administrarive Tag Sub-TLV speficied in this document. This will facilitate backward compatibility with implementations that do not support this specification.
An OSPF router supporting this specification SHOULD propagate administrative tags when acting as an Area Border Router and originating summary advertisements into other areas (unless inhibited by local policy Section 6). Similarly, an OSPF router supporting this specification and acting as an ABR for a Not-So-Stubby Area (NSSA) SHOULD propagate tags when translating NSSA routes to AS External advertisements [RFC3101] (also subject to local policy Section 6).
There is no implied meaning to the ordering of the tags that indicates a certain operation or set of operations need be performed based on the order of the tags. Each tag SHOULD be treated as an autonomous identifier that MAY be used in policy to perform a policy action. Whether or not tag A precedes or succeeds tag B SHOULD not change the meaning of the tag set. The number of tags supported MAY limit the number of tags that are propagated. When propagating multiple tags between areas as previously described, the order of the the tags MUST be preserved so that implementations supporting fewer tags will have a consistent view across areas.
For configured area ranges, NSSA ranges, and configured aggregation of redistributed routes, tags from component routes SHOULD NOT be propagated to the summary. Implementations SHOULD provide a mechanism to configure multiple tags for area ranges, NSSA ranges, and redistributed route summaries.

Equal-Cost Multipath Applicability
When multiple LSAs contribute to an OSPF route, it is possible that these LSAs will all have different tags. In this situation, the OSPF router MUST associate the tags from one of the LSAs contributing a path and, if the implementation supports multiple tags, MAY associate tags from multiple contributing LSAs up to the maximum number of tags supported. It is RECOMMENDED that tags from LSAs are added to the path in ascending order of LSA originator Router-ID.

BGP-LS Advertisement
BGP-LS [RFC9552] introduced the support for advertising administrative tags associated with prefixes using the BGP-LS IGP Route Tag TLV (TLV 1153). This BGP-LS TLV is used to advertise the OSPF Administrative Tags specified in this document.

Management Considerations
Implementations MAY include configuration of policies to inhibit the advertisement of tags for redistributed prefixes. Implementations MAY also include configuration of policies to filter the propagation of admin-tags between areas (OSPFv2 Extended Prefix LSAs, OSPFv3 E-Inter-Area-Prefix-LSAs, and translated OSPFv3 E-AS-External-LSAs). However, the default behavior SHOULD be to advertise or propagate the lesser number of all the tags associated with the prefix or the maximum number of tags supported by the implementation.
Both the support of this specification and the number of tags supported by OSPF routers within an OSPF routing domain will limit the usefulness and deployment of applications utilizing tags.

YANG Data Model
YANG [RFC7950] is a data definition language used to define the contents of a conceptual data store that allows networked devices to be managed using NETCONF [RFC6241] or RESTCONF [RFC8040].
This section defines a YANG data model that can be used to configure and manage the prefix administrative tags defined in this document, which augments the OSPF YANG data model [RFC9129] and the OSPFv3 Extended LSA YANG data model [RFC9587].

Tree for the YANG Data Model
This document uses the graphical representation of data models per [RFC8340].
The following show the tree diagram of the module:

module: ietf-ospf-admin-tags

 augment /rt:routing/rt:control-plane-protocols
         /rt:control-plane-protocol/ospf:ospf/ospf:areas/ospf:area
         /ospf:ranges/ospf:range:
   +--rw admin-tags
      +--rw admin-tag*   uint32
 augment /rt:routing/rt:control-plane-protocols
         /rt:control-plane-protocol/ospf:ospf/ospf:areas/ospf:area
         /ospf:ranges/ospf:range:
   +--rw admin-tag*   uint32
 augment /rt:routing/rt:control-plane-protocols
         /rt:control-plane-protocol/ospf:ospf/ospf:areas/ospf:area
         /ospf:interfaces/ospf:interface:
   +--rw local-prefix-admin-tags
      +--rw default-admin-tag*           uint32
      +--rw specific-prefix-admin-tag* [prefix]
         +--rw prefix       inet:ip-prefix
         +--rw admin-tag*   uint32
 augment /rt:routing/rt:control-plane-protocols
         /rt:control-plane-protocol/ospf:ospf/ospf:local-rib
         /ospf:route/ospf:next-hops/ospf:next-hop:
   +--ro admin-tag*   uint32
 augment /rt:routing/rt:control-plane-protocols
         /rt:control-plane-protocol/ospf:ospf/ospf:areas/ospf:area
         /ospf:interfaces/ospf:interface/ospf:database
         /ospf:link-scope-lsa-type/ospf:link-scope-lsas
         /ospf:link-scope-lsa/ospf:version/ospf:ospfv2/ospf:ospfv2
         /ospf:body/ospf:opaque/ospf:extended-prefix-opaque
         /ospf:extended-prefix-tlv:
   +--ro prefix-admin-tag-sub-tlv
      +--ro admin-tag*   uint32
 augment /rt:routing/rt:control-plane-protocols
         /rt:control-plane-protocol/ospf:ospf/ospf:areas/ospf:area
         /ospf:database/ospf:area-scope-lsa-type/ospf:area-scope-lsas
         /ospf:area-scope-lsa/ospf:version/ospf:ospfv2/ospf:ospfv2
         /ospf:body/ospf:opaque/ospf:extended-prefix-opaque
         /ospf:extended-prefix-tlv:
   +--ro prefix-admin-tag-sub-tlv
      +--ro admin-tag*   uint32
 augment /rt:routing/rt:control-plane-protocols
         /rt:control-plane-protocol/ospf:ospf/ospf:database
         /ospf:as-scope-lsa-type/ospf:as-scope-lsas/ospf:as-scope-lsa
         /ospf:version/ospf:ospfv2/ospf:ospfv2/ospf:body/ospf:opaque
         /ospf:extended-prefix-opaque/ospf:extended-prefix-tlv:
   +--ro prefix-admin-tag-sub-tlv
      +--ro admin-tag*   uint32
 augment /rt:routing/rt:control-plane-protocols
         /rt:control-plane-protocol/ospf:ospf/ospf:areas/ospf:area
         /ospf:database/ospf:area-scope-lsa-type/ospf:area-scope-lsas
         /ospf:area-scope-lsa/ospf:version/ospf:ospfv3/ospf:ospfv3
         /ospf:body/ospfv3-e-lsa:e-inter-area-prefix
         /ospfv3-e-lsa:e-inter-prefix-tlvs
         /ospfv3-e-lsa:inter-prefix-tlv:
   +--ro prefix-admin-tag-sub-tlv
      +--ro admin-tag*   uint32
 augment /rt:routing/rt:control-plane-protocols
         /rt:control-plane-protocol/ospf:ospf/ospf:areas/ospf:area
         /ospf:database/ospf:area-scope-lsa-type/ospf:area-scope-lsas
         /ospf:area-scope-lsa/ospf:version/ospf:ospfv3/ospf:ospfv3
         /ospf:body/ospfv3-e-lsa:e-intra-area-prefix
         /ospfv3-e-lsa:e-intra-prefix-tlvs
         /ospfv3-e-lsa:intra-prefix-tlv:
   +--ro prefix-admin-tag-sub-tlv
      +--ro admin-tag*   uint32
 augment /rt:routing/rt:control-plane-protocols
         /rt:control-plane-protocol/ospf:ospf/ospf:database
         /ospf:as-scope-lsa-type/ospf:as-scope-lsas/ospf:as-scope-lsa
         /ospf:version/ospf:ospfv3/ospf:ospfv3/ospf:body
         /ospfv3-e-lsa:e-as-external/ospfv3-e-lsa:e-external-tlvs
         /ospfv3-e-lsa:external-prefix-tlv:
   +--ro prefix-admin-tag-sub-tlv
      +--ro admin-tag*   uint32
 augment /rt:routing/rt:control-plane-protocols
         /rt:control-plane-protocol/ospf:ospf/ospf:areas/ospf:area
         /ospf:database/ospf:area-scope-lsa-type/ospf:area-scope-lsas
         /ospf:area-scope-lsa/ospf:version/ospf:ospfv3/ospf:ospfv3
         /ospf:body/ospfv3-e-lsa:e-nssa/ospfv3-e-lsa:e-external-tlvs
         /ospfv3-e-lsa:external-prefix-tlv:
   +--ro prefix-admin-tag-sub-tlv
      +--ro admin-tag*   uint32

YANG Data Model for OSPF Prefix Administrative Tags
The following is the YANG module:

module ietf-ospf-admin-tags {
  yang-version 1.1;
  namespace "urn:ietf:params:xml:ns:yang:ietf-ospf-admin-tags";
  prefix ospf-admin-tags;

  import ietf-routing {
    prefix rt;
    reference
      "RFC 8349: A YANG Data Model for Routing
       Management (NMDA Version)";
  }
  import ietf-ospf {
    prefix ospf;
    reference
      "RFC 9129: YANG Data Model for the OSPF Protocol";
  }
  import ietf-inet-types {
    prefix inet;
    reference
      "RFC 6991: Common YANG Data Types";
  }
  import ietf-ospfv3-extended-lsa {
    prefix ospfv3-e-lsa;
    reference
      "RFC 9587: YANG Data Model for OSPFv3 Extended Link
                 State Advertisements (LSAs)";
  }

  organization
    "IETF LSR - Link State Routing Working Group";
  contact
    "WG Web:   <https://datatracker.ietf.org/wg/lsr/>
     WG List:  <mailto:lsr@ietf.org>

     Author:   Yingzhen Qu
               <mailto:yingzhen.ietf@gmail.com>
     Author:   Acee Lindem
               <mailto:acee.ietf@gmail.com>
     Author:   Peter Psenak
               <mailto:ppsenak@cisco.com>";
  description
    "This YANG module defines the configuration
     and operational state for OSPF administrative tags.

     This YANG model conforms to the Network Management
     Datastore Architecture (NMDA) as described in RFC 8342.

     Copyright (c) 2024 IETF Trust and the persons identified as
     authors of the code.  All rights reserved.

     Redistribution and use in source and binary forms, with or
     without modification, is permitted pursuant to, and subject to
     the license terms contained in, the Revised BSD License set
     forth in Section 4.c of the IETF Trust's Legal Provisions
     Relating to IETF Documents
     (https://trustee.ietf.org/license-info).

     This version of this YANG module is part of RFC XXXX;
     see the RFC itself for full legal notices.

     The key words 'MUST', 'MUST NOT', 'REQUIRED', 'SHALL', 'SHALL
     NOT', 'SHOULD', 'SHOULD NOT', 'RECOMMENDED', 'NOT RECOMMENDED',
     'MAY', and 'OPTIONAL' in this document are to be interpreted as
     described in BCP 14 (RFC 2119) (RFC 8174) when, and only when,
     they appear in all capitals, as shown here.";
  reference
    "RFC XXXX";

  revision 2024-07-22 {
    description
      "Initial revision.";
    reference
      "RFC XXXX: Extensions to OSPF for Advertising Prefix
                 Administrative Tags.";
  }

  grouping prefix-admin-tag-sub-tlv {
    description
      "Prefix Administrative Tag sub-TLVs.";
    container prefix-admin-tag-sub-tlv {
      config false;
      description
        "Prefix admin tag sub-TLV.";
      leaf-list admin-tag {
        type uint32;
        description
          "Administrative tags.";
      }
    }
  }

  /* Configuration */

  augment "/rt:routing/rt:control-plane-protocols/"
        + "rt:control-plane-protocol/ospf:ospf/"
        + "ospf:areas/ospf:area/ospf:ranges/ospf:range" {
    when "derived-from-or-self(../../../../../"
       + "rt:type, 'ospf:ospf')" {
      description
        "This augments the OSPF routing protocol area range
         configuration.";
    }
    description
      "This augments the OSPF protocol area range configuration
       with administrative tags. The configured tags will be
       advertised with summary prefix when it is active.";
    container admin-tags {
      when "../ospf:advertise = 'true'";
      leaf-list admin-tag {
        type uint32;
        description
          "Administrative tags.";
      }
      description
        "OSPF prefix administrative tags.";
    }
  }

  augment "/rt:routing/rt:control-plane-protocols/"
        + "rt:control-plane-protocol/ospf:ospf/"
        + "ospf:areas/ospf:area/ospf:ranges/ospf:range" {
    when "derived-from-or-self(../../../../../"
       + "rt:type, 'ospf:ospf')" {
      description
        "This augments the OSPF routing protocol area range
         configuration.";
    }
    description
      "This augments summary route configuration with
       administrative tags.";
      leaf-list admin-tag {
        type uint32;
        description
          "Administrative tags.";
      }
  }

  augment "/rt:routing/rt:control-plane-protocols/"
        + "rt:control-plane-protocol/ospf:ospf/"
        + "ospf:areas/ospf:area/ospf:interfaces/ospf:interface" {
    when "derived-from-or-self(../../../../../"
       + "rt:type, 'ospf:ospf')" {
      description
        "This augments the OSPF routing protocol interface
         configuration.";
    }
    description
      "This augments the OSPF protocol interface configuration
       with Administrative Tags. The configured tags will be
       advertised with local prefixes configured for the interface.";
    container local-prefix-admin-tags {
      leaf-list default-admin-tag {
        type uint32;
        description
          "Administrative tags that will be associated with
           local prefixes if the prefix is not specified explicitly.
           If omitted, no admin tags are associated with local
           prefixes by default.";
      }
      list specific-prefix-admin-tag {
        key "prefix";
        leaf prefix {
          type inet:ip-prefix;
          description
            "IPv4 or IPv6 prefix";
        }
        leaf-list admin-tag {
          type uint32;
          description
            "Administrative tags that will be associated with
             the specified local prefix. If omitted, no admin tags
             are associated with the specified local prefix.";
        }
        description
          "Admin tags that are explicitly associated with
           the specified prefix.";
      }
      description
        "List of administrative tags that are to be advertised
         with interface local prefixes.";
    }
  }

  /* Local-RIB */
  augment "/rt:routing/"
        + "rt:control-plane-protocols/rt:control-plane-protocol/"
        + "ospf:ospf/ospf:local-rib/ospf:route/ospf:next-hops/"
        + "ospf:next-hop" {
    description
      "This augments local-rib next-hop with administrative tags.";
      leaf-list admin-tag {
        type uint32;
        description
          "Administrative tags.";
      }
  }

  /* Database */

  augment "/rt:routing/"
        + "rt:control-plane-protocols/rt:control-plane-protocol/"
        + "ospf:ospf/ospf:areas/ospf:area/"
        + "ospf:interfaces/ospf:interface/ospf:database/"
        + "ospf:link-scope-lsa-type/ospf:link-scope-lsas/"
        + "ospf:link-scope-lsa/ospf:version/ospf:ospfv2/"
        + "ospf:ospfv2/ospf:body/ospf:opaque/"
        + "ospf:extended-prefix-opaque/ospf:extended-prefix-tlv" {
    when "derived-from-or-self(../../../../../../../../../../"
       + "../../../../rt:type, 'ospf:ospfv2')" {
      description
        "This augmentation is only valid for OSPFv2.";
    }
    description
      "Prefix Administrative Tag Sub-TLVs for OSPFv2 extended prefix
       TLV in type 9 opaque LSA.";
    uses prefix-admin-tag-sub-tlv;
  }

  augment "/rt:routing/"
        + "rt:control-plane-protocols/rt:control-plane-protocol/"
        + "ospf:ospf/ospf:areas/"
        + "ospf:area/ospf:database/"
        + "ospf:area-scope-lsa-type/ospf:area-scope-lsas/"
        + "ospf:area-scope-lsa/ospf:version/ospf:ospfv2/"
        + "ospf:ospfv2/ospf:body/ospf:opaque/"
        + "ospf:extended-prefix-opaque/ospf:extended-prefix-tlv" {
    when "derived-from-or-self(../../../../../../../../../../"
       + "../../rt:type, 'ospf:ospfv2')" {
      description
        "This augmentation is only valid for OSPFv2.";
    }
    description
      "Prefix Administrative Tag Sub-TLVs for OSPFv2 extended prefix
       TLV in type 10 opaque LSA.";
    uses prefix-admin-tag-sub-tlv;
  }

  augment "/rt:routing/"
        + "rt:control-plane-protocols/rt:control-plane-protocol/"
        + "ospf:ospf/ospf:database/"
        + "ospf:as-scope-lsa-type/ospf:as-scope-lsas/"
        + "ospf:as-scope-lsa/ospf:version/ospf:ospfv2/"
        + "ospf:ospfv2/ospf:body/ospf:opaque/"
        + "ospf:extended-prefix-opaque/ospf:extended-prefix-tlv" {
    when "derived-from-or-self(../../../../../../../../"
       + "../../rt:type, 'ospf:ospfv2')" {
      description
        "This augmentation is only valid for OSPFv2.";
    }
    description
      "Prefix Administrative Tag Sub-TLVs for OSPFv2 extended prefix
       TLV in type 11 opaque LSA.";
    uses prefix-admin-tag-sub-tlv;
  }

  augment "/rt:routing/"
        + "rt:control-plane-protocols/rt:control-plane-protocol/"
        + "ospf:ospf/ospf:areas/ospf:area/ospf:database/"
        + "ospf:area-scope-lsa-type/ospf:area-scope-lsas/"
        + "ospf:area-scope-lsa/ospf:version/ospf:ospfv3/"
        + "ospf:ospfv3/ospf:body/ospfv3-e-lsa:e-inter-area-prefix/"
        + "ospfv3-e-lsa:e-inter-prefix-tlvs/"
        + "ospfv3-e-lsa:inter-prefix-tlv" {
    when "derived-from-or-self(../../../../../../../../../../"
       + "../../rt:type, 'ospf:ospfv3')" {
      description
        "This augmentation is only valid for OSPFv3.";
    }
    description
      "Augment OSPFv3 Inter-Area-Prefix TLV in the
       E-Inter-Area-Prefix LSA.";
    uses prefix-admin-tag-sub-tlv;
  }

  augment "/rt:routing/"
        + "rt:control-plane-protocols/rt:control-plane-protocol/"
        + "ospf:ospf/ospf:areas/ospf:area/ospf:database/"
        + "ospf:area-scope-lsa-type/ospf:area-scope-lsas/"
        + "ospf:area-scope-lsa/ospf:version/ospf:ospfv3/"
        + "ospf:ospfv3/ospf:body/ospfv3-e-lsa:e-intra-area-prefix/"
        + "ospfv3-e-lsa:e-intra-prefix-tlvs/"
        + "ospfv3-e-lsa:intra-prefix-tlv" {
    when "/rt:routing/rt:control-plane-protocols"
       + "/rt:control-plane-protocol/rt:type = 'ospf:ospfv3'" {
      description
        "This augmentation is only valid for OSPFv3.";
    }
    description
      "Augment OSPFv3 Intra-Area-Prefix TLV in the
       E-Intra-Area-Prefix LSA.";
    uses prefix-admin-tag-sub-tlv;
  }

  augment "/rt:routing/"
        + "rt:control-plane-protocols/rt:control-plane-protocol/"
        + "ospf:ospf/ospf:database/"
        + "ospf:as-scope-lsa-type/ospf:as-scope-lsas/"
        + "ospf:as-scope-lsa/ospf:version/ospf:ospfv3/"
        + "ospf:ospfv3/ospf:body/ospfv3-e-lsa:e-as-external/"
        + "ospfv3-e-lsa:e-external-tlvs/"
        + "ospfv3-e-lsa:external-prefix-tlv" {
    when "derived-from-or-self(../../../../../../../../"
       + "../../rt:type, 'ospf:ospfv3')" {
      description
        "This augmentation is only valid for OSPFv3.";
    }
    description
      "Augment OSPFv3 External-Prefix TLV in the E-AS-External-LSA.";
    uses prefix-admin-tag-sub-tlv;
  }

  augment "/rt:routing/"
        + "rt:control-plane-protocols/rt:control-plane-protocol/"
        + "ospf:ospf/ospf:areas/ospf:area/ospf:database/"
        + "ospf:area-scope-lsa-type/ospf:area-scope-lsas/"
        + "ospf:area-scope-lsa/ospf:version/ospf:ospfv3/"
        + "ospf:ospfv3/ospf:body/ospfv3-e-lsa:e-nssa/"
        + "ospfv3-e-lsa:e-external-tlvs/"
        + "ospfv3-e-lsa:external-prefix-tlv" {
    when "/rt:routing/rt:control-plane-protocols"
       + "/rt:control-plane-protocol/rt:type = 'ospf:ospfv3'" {
      description
        "This augmentation is only valid for OSPFv3.";
    }
    description
      "Augment OSPFv3 External-Prefix TLV in the E-NSSA-LSA.";
    uses prefix-admin-tag-sub-tlv;
  }
}

Security Considerations
This document describes a generic mechanism for advertising administrative tags for OSPF prefixes. The administrative tags are generally less critical than the topology information currently advertised by the base OSPF protocol. The security considerations for the generic mechanism are dependent on their application. One such application is to control leaking of OSPF routes to other protocols (e.g., BGP [RFC4271]). If an attacker were able to modify the admin tags associated with OSPF routes and they were being used for this application, such routes could be prevented from being advertised in routing domains where they are required (subtle denial or service) or they could be advertised into routing domains where they shouldn't be advertised (routing vulnerability). Security considerations for the base OSPF protocol are covered in [RFC2328] and [RFC5340].
The YANG modules specified in this document define a schema for data that is designed to be accessed via network management protocols such as NETCONF [RFC6241] or RESTCONF [RFC8040]. The lowest NETCONF layer is the secure transport layer, and the mandatory-to-implement secure transport is Secure Shell (SSH) [RFC6242]. The lowest RESTCONF layer is HTTPS, and the mandatory-to-implement secure transport is TLS [RFC8446].
The NETCONF Access Control Model (NACM) [RFC8341] provides the means to restrict access for particular NETCONF or RESTCONF users to a pre-configured subset of all available NETCONF or RESTCONF protocol operations and content.
The following data nodes defined in the YANG module that are writable/creatable/deletable (i.e., config true, which is the default). The modifications to these data nodes without proper protection can have a negative effect on network operations.
- /ospf:ospf/ospf:areas/ospf:area/ospf:interfaces/ospf:interface/local-prefix-admin-tags
- /ospf:ospf/ospf:areas/ospf:area/ospf:ranges/ospf:range/admin-tags
Some of the readable data nodes in this YANG module may be considered sensitive or vulnerable in some network environments. Exposure of the OSPF link state database may be useful in mounting a Denial-of-Service (DoS) attacks. These are the readable data nodes:
- /ospf:ospf/ospf:areas/ospf:area/ospf:interfaces/ospf:interface/local-prefix-admin-tags
- /ospf:ospf/ospf:areas/ospf:area/ospf:ranges/ospf:range/admin-tags
- /prefix-admin-tag-sub-tlv

IANA Considerations
The following values should be allocated from the "OSPF Extended Prefix TLV Sub-TLV" Registry [RFC7684]:
- TBD - Administrative Tag Sub-TLV
The following values should be allocated from the "OSPFv3 Extended-LSA Sub-TLV" Registry [RFC8362]:
- TBD - Administrative Tag Sub-TLV
The following values should be allocated from the "OSPFv3 SRv6 Locator LSA Sub-TLVs" Registry [RFC9513]:
- TBD - Administrative Tag Sub-TLV
The IANA is requested to assign one new URI from the IETF XML registry ([RFC3688]). Authors are suggesting the following URI:

URI: urn:ietf:params:xml:ns:yang:ietf-ospf-admin-tags
Registrant Contact: The IESG.
XML: N/A, the requested URI is an XML namespace

This document also requests one new YANG module name in the YANG Module Names registry ([RFC6020]) with the following suggestion :

name: ietf-ospf-admin-tags
namespace: urn:ietf:params:xml:ns:yang:ietf-ospf-admin-tags
prefix: ospf-admin-tags
reference: RFC XXXX

Acknowledgments
The authors of RFC 5130 [RFC5130] are acknowledged since this document draws upon both the IS-IS specification and deployment experience. The text in Section 4 is adopted from RFC 5130.
Thanks to Donnie Savage for his comments and questions.
Thanks to Ketan Talaulikar for his comments and providing the BGP-LS text.
Thanks to Tony Przygienda and Les Ginsberg for discussions on tag selection.
Thanks to Russ White for his Routing Directorate review.
Thanks to Bruno Decraene and Changwang Lin working group last call comments.

Normative References

Informative References
[RFC2328]
[RFC5340]
[RFC7684]
[RFC8362]
[RFC5130]
[RFC2119]
[RFC8174]
[RFC9513]
[RFC3101]
[RFC9552]
[RFC7950]
[RFC6241]
[RFC8040]
[RFC9129]
[RFC9587]
[RFC8340]
[RFC4271]
[RFC6242]
[RFC8446]
[RFC8341]
[RFC3688]
[RFC6020]